/*
        CGenericConfig.cpp TimeTrack V1.0
        @Author: Thomas Thiel
        @EMail: thielt@cs.uni-bonn.de
        @Created: 20010623
 
        This class is GPL Code. Feel free to distribute, change and burn
        this code, but always burn the authors name with it !

        If you seek docs to this piece of code, look into CGenericConfig.h !
*/

#include <iostream>

using std::cout;
using std::cin;
using std::cerr;
using std::clog;
using std::endl;

#include "CGenericConfig.h"


CGenericConfig::CGenericConfig (QString filename)
{
  fh = new QFile (filename);
  ts = new QTextStream (fh);

  readConfig ();
}

CGenericConfig::~CGenericConfig ()
{
  // Qt does the dumb stuff for us....
}

bool
CGenericConfig::readConfig ()
{
  if (fh->open (IO_ReadOnly))
    {
      while (!ts->atEnd ())
	{
	  QString momInp = ts->readLine ();
	  momInp = momInp.simplifyWhiteSpace ();
	  momInp = momInp.stripWhiteSpace ();
	  if ((momInp[0] != '#') & (momInp != ""))
	    {
	      QString momID (momInp);
	      QString momVal (momInp);

	      momID.truncate (momID.find ('=') - 1);
	      momID = momID.stripWhiteSpace ();

	      momVal = momVal.remove (0, momVal.find ('=') + 1);
	      momVal = momVal.stripWhiteSpace ();

	      identifiers.append (momID);
	      values.append (momVal);
	    };
	};
      fh->close ();
    }
  else
    return false;

  return true;
};

bool
CGenericConfig::writeConfig ()
{
  if (!fh->open (IO_WriteOnly))
    return false;

  QStringList::Iterator id_it = identifiers.begin ();
  QStringList::Iterator val_it = values.begin ();

  *ts << "# Config file generated by CGenericConfig of TimeTrack" << endl;

  while (id_it != identifiers.end ())
    {
      *ts << *id_it << " = " << *val_it << endl;
      id_it++;
      val_it++;
    };

  fh->close ();

  return true;
};

bool
CGenericConfig::addValue (QString id, QString val)
{
  QStringList::Iterator id_it = identifiers.begin ();
  QStringList::Iterator val_it = values.begin ();

  bool found = false;

  while (id_it != identifiers.end ())
    {
      if (*id_it == id)
	{
	  *val_it = val;
	  found = true;
	};
      id_it++;
      val_it++;
    };

  if (!found)
    {
      identifiers.append (id);
      values.append (val);
    }

  return true;
};

bool
CGenericConfig::remValue (QString id)
{
  QStringList::Iterator id_it = identifiers.begin ();
  QStringList::Iterator val_it = values.begin ();

  while (id_it != identifiers.end ())
    {
      if (*id_it == id)
	{
	  identifiers.remove (id_it);
	  values.remove (val_it);
	  return true;
	};
      id_it++;
      val_it++;
    };
  return false;
};

QString
CGenericConfig::getValue (QString id)
{
  QStringList::Iterator id_it = identifiers.begin ();
  QStringList::Iterator val_it = values.begin ();

  while (id_it != identifiers.end ())
    {
      if (*id_it == id)
	return *val_it;
      id_it++;
      val_it++;
    };

  return QString ();
};

int
CGenericConfig::getIntValue (QString id)
{
  QString mom (getValue (id));
  return mom.toInt ();
};

/** Prft auf Vorhandensein eines Tupels */
bool
CGenericConfig::existValue (QString label)
{
  QStringList::Iterator id_it = identifiers.begin ();

  while (id_it != identifiers.end ())
    {
      if (*id_it == label)
	return true;
      id_it++;
    };

  return false;
}
