/***************************************************************************
 *   Copyright (C) 2004 by Thomas Thiel                                    *
 *   wolfchild@wolfchild.de                                                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef CMAINWINDOW_H
#define CMAINWINDOW_H

#include <qmainwindow.h>
#include <qtabwidget.h>
#include <qscrollview.h>
#include <qaction.h>
#include <qpopupmenu.h>
#include <qtoolbar.h>
#include <qsplashscreen.h>

/**
The main application window. Holds all the CTimerWidgets and handles the extended abilities of this program.

@author Thomas Thiel
*/

// please read the implementation for documentation.

class CMainWindow : public QMainWindow
{
Q_OBJECT
public:
    CMainWindow(QWidget *parent = 0, const char *name = 0);
    ~CMainWindow();
    
		void init();
		void showSplash();
    virtual QWidget* getSplitter(const QWidget *tabwidget );
    virtual long int duration_all();
    virtual long int duration_tab(const int & index);
    
    QTabWidget *tabwidget;
    QScrollView *scrollview;
    QAction *filesave,*filesaveas; // don't ask... I'm too lazy to write access methods for these two. ;)
    QString currentFile; //...as above. ;)


private:
    QString CMainWindow::time_to_str(const long int & interval);
   
protected:
    QAction *about, *fileexport, *fileimport, *fileload, *newtimer, *newtab, *options, *clearall, *clearcurrent, *renametab, *quit, *report_all, *report_tab;
    QPopupMenu *file, *help;
    QToolBar *tools,*filetools;
    
    void saveFile(const QString & filename);
    void loadFile(const QString & filename);
		
		QPixmap *img_fileload, *img_filesave, *img_newtimer, *img_newtab, *img_options, *img_clearall, *img_renametab, *img_quit;
    
		QPixmap *splash_image;
		QSplashScreen *splash;
		
	
		
public slots:
    void spawnnewtab();
    void spawnnewcounter();
		void load();
		void insertFile();
		void exportFile();
		void saveAs();
		void saveCurrent();
		void clearAll();
		void clearCurrent();
		void renameTab();
		void hideSplash();
		void showAbout();
		void showOptions();
		void close();
		void reportTab();
		void reportAll();

};

#endif
