/***************************************************************************
 *   Copyright (C) 2004 by Thomas Thiel                                    *
 *   wolfchild@wolfchild.de                                                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef CREPORTGENERATOR_H
#define CREPORTGENERATOR_H

#include "ReportGenerator.h"

class CReportGenerator : public ReportGenerator
{
  Q_OBJECT

public:
  CReportGenerator(QWidget* parent = 0, const char* name = 0, WFlags fl = 0 );
  ~CReportGenerator();
  /*$PUBLIC_FUNCTIONS$*/
  
  virtual QString getDocFooter_substituted(const QString & duration_all = "n/a",
  					   const QString & filename = "n/a");
  virtual QString getDocHeader_substituted(const QString & duration_all = "n/a",
  					   const QString & filename = "n/a");
  virtual QString getTabFooter_substituted(const QString & tabname = "unnamed tab",
  					   const QString & duration_tab = "n/a",
  					   const QString & duration_all = "n/a",   
                                           const QString & filename = "n/a");
  virtual QString getTabHeader_substituted(const QString & tabname = "unnamed tab", 
  					   const QString & duration_tab = "n/a",
  					   const QString & duration_all = "n/a",   
                                           const QString & filename = "n/a");
  virtual QString getTimerFooter_substituted(const QString & timername = "unnamed Timer", 
                                             const QString & timerdesc = "N/A",
					     const QString & tabname = "unnamed tab", 
					     const QString & duration = "n/a",
  					     const QString & duration_tab = "n/a",
  					     const QString & duration_all = "n/a",   
					     const QString & filename = "n/a");
  virtual QString getTimerHeader_substituted(const QString & timername = "unnamed Timer", 
                                             const QString & timerdesc = "N/A", 
					     const QString & tabname = "unnamed tab", 
					     const QString & duration = "n/a",
  					     const QString & duration_tab = "n/a",
  					     const QString & duration_all = "n/a",   
					     const QString & filename = "n/a");
  virtual QString getEntriesHeader_substituted(const QString & timername = "unnamed Timer", 
                                               const QString & timerdesc = "N/A",
					       const QString & tabname = "unnamed tab", 
					       const QString & duration = "n/a",
  					       const QString & duration_tab = "n/a",
  					       const QString & duration_all = "n/a",   
					       const QString & filename = "n/a");
  virtual QString getEntriesFooter_substituted(const QString & timername = "unnamed Timer", 
                                               const QString & timerdesc = "N/A",
					       const QString & tabname = "unnamed tab", 
					       const QString & duration = "n/a",
					       const QString & duration_tab = "n/a",
  					       const QString & duration_all = "n/a",   
					       const QString & filename = "n/a");
  virtual QString getSingleEntry_substituted(const QString & entrystart = "n/a", 
                                             const QString & entrystop = "n/a", 
					     const QString & entrydesc = "no description", 
					     const QString & timername = "unnamed Timer", 
					     const QString & timerdesc = "N/A",
					     const QString & tabname = "unnamed tab", 
					     const QString & single_duration = "n/a",
					     const QString & duration = "n/a",
					     const QString & duration_tab = "n/a",
					     const QString & duration_all = "n/a",   
					     const QString & filename = "n/a");
    virtual void loadFile(const QString & filename);


public slots:
  /*$PUBLIC_SLOTS$*/
  virtual void          resetDefaults_pressed();
  virtual void          saveTemplate_pressed();
  virtual void          loadTemplate_pressed();


protected:
  /*$PROTECTED_FUNCTIONS$*/

protected slots:
  /*$PROTECTED_SLOTS$*/

};

#endif

