/***************************************************************************
 *   Copyright (C) 2004 by Thomas Thiel                                    *
 *   wolfchild@wolfchild.de                                                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef CTIMEREDITDIALOG_H
#define CTIMEREDITDIALOG_H

#include <qdatetime.h>
#include <qptrlist.h>
#include "ctimerentry.h"
#include "timereditdialog.h"

// please read the implementation for documentation.

class CTimerEditDialog : public TimerEditDialog
{
    Q_OBJECT

public:
    
    CTimerEditDialog(QPtrList<CTimerEntry> *inp_EntryList,  QWidget* parent = 0, const char* name = 0, bool modal = FALSE, WFlags fl = 0 );
    ~CTimerEditDialog();

public slots:
    /*$PUBLIC_SLOTS$*/
    virtual void          add_entry_pressed();
    virtual void          delete_entry_pressed();
    virtual void          change_entry_pressed();
    virtual void	  close();

    virtual int nextFreeId();
        
protected:
    /*$PROTECTED_FUNCTIONS$*/
    QPtrList<CTimerEntry> *EntryList;
    //QListView lvw_entrylist;
    QListViewItem *lastItem;
    
protected slots:
    /*$PROTECTED_SLOTS$*/
    virtual void          entrylist_currentChanged(QListViewItem *item);

private:

};

#endif

