/***************************************************************************
 *   Copyright (C) 2004 by Thomas Thiel                                    *
 *   wolfchild@wolfchild.de                                                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef CTIMERWIDGET_H
#define CTIMERWIDGET_H

#include <qtimer.h>
#include <qdatetime.h>
#include <qptrlist.h>
#include <qdom.h>
#include <qstring.h>

#include "cmainwindow.h"
#include "timerwidget.h"
#include "ctimerentry.h"
#include "creportgenerator.h"

// please read the implementation for documentation.

class CTimerWidget : public TimerWidget
{
  Q_OBJECT
  
public:
  CTimerWidget(QWidget* parent = 0, const char* name = 0, WFlags fl = 0 );
  CTimerWidget(CMainWindow* mainwin, QWidget* parent = 0, const char* name = 0, WFlags fl = 0 );
  ~CTimerWidget();
  QString tabname;
 
  /*$PUBLIC_FUNCTIONS$*/
  virtual QString report(CReportGenerator *repgen, const QString & filename 
  = "n/a", long int duration_tab = 0, long int duration_all = 0, bool with_headers = false);
  long int CTimerWidget::calcInterval();

  virtual int nextFreeId();
  
  
public slots:
    /*$PUBLIC_SLOTS$*/
    virtual void          action_changed(const QString&);
    virtual void          startstop_pressed();
    void timersignal();
    QDomElement writeTimerData();
		void readTimerData(const QDomElement & dom_input);
    
protected:
  /*$PROTECTED_FUNCTIONS$*/
    
protected slots:
  /*$PROTECTED_SLOTS$*/

protected:
    QTimer *timer;
    long int interval;
    bool count;
    CTimerEntry *activeEntry;
    QPtrList<CTimerEntry> entryList;
    QString description;
    CMainWindow* mainwindow;
private:
    virtual QString time_to_str(const long int & inp);
};

#endif

